// Standardausgabe verwenden
#include <iostream>
using namespace std;

class CObject
{
  public:

    CObject()    { cout << "Konstruktor" << endl; }
    ~CObject()   { cout << "Destruktor"  << endl; }
    void print() { cout << "Print"       << endl; }
};


void dynamicArray(unsigned int size)
{
    // Laufvariable deklarieren
    unsigned int i;

    // Array im Speicher anlegen
    int* a = new int[size];

    // Array initialisieren
    for (i = 0; i < size; i++)
    {
        a[i] = int(i);
    }

    for (i = 0; i < size; i++)
    {
        // Werte von a ausgeben
        if (i+1 < size)
            cout << a[i] << " | ";
        else
            cout << a[i] << endl;
    }

    // Array lschen (die eckigen Klammern beachten)
    delete[] a;
}


void dynamicObject()
{
    // einzelnes Objekt erzeugen
    CObject* o = new CObject();

    // Objektfuntkion aufrufen
    (*o).print();
    // Dasselbe in einfacherer Notation
    o->print();

    // Objekt lschen (ohne eckige Klammern)
    delete o;
}


void objectArray(unsigned int size)
{
    // Array von Objekten erzeugen
    // (Konstruktor wird aufgerufen)
    CObject* o = new CObject[size];

    // auf Objekte zugreifen
    for (unsigned int i = 0; i < size; i++)
    {
        o[i].print();
    }

    // Objekte lschen (mit eckigen Klammern)
    // (Destruktor wird aufgerufen)
    delete[] o;
}


int main()
{
    dynamicArray(5);
    cout << endl;

    dynamicObject();
    cout << endl;

    objectArray(5);

} // main()
